package edu.harvard.mgh.purcell.gplink.forms;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;

import edu.harvard.mgh.purcell.gplink.base_form.*;
import edu.harvard.mgh.purcell.gplink.mainGUI.*;

@SuppressWarnings("serial")
public class RecodeForm extends Forms {

	// the various options
	private Forms.myRadioButton recode, recodeAD, recode12, recodeHV, makeBin;
	
	@Override
	protected String processBody() {
		String ans = "";
		
		if(recode.isSelected())
			ans = "--recode";
		if(recodeAD.isSelected())
			ans = "--recodeAD";
		if(recode12.isSelected())
			ans = "--recode12";
		if(recodeHV.isSelected())
			ans = "--recodeHV";
		if(makeBin.isSelected())
			ans = "--make-bed";
		
		return ans;
	}

	@Override
	protected boolean isBodyValid() {
		if (recode.isSelected() || recodeAD.isSelected() 
				|| recode12.isSelected()
				|| recodeHV.isSelected()
				|| makeBin.isSelected())
			return true;
		else{
//			information.setText("Select a recode option.");
			return false;
		}
	}
	
	@Override
	protected void createBody() {

	    //	 put them all in a group so we can only select one at a
		// ...time
		ButtonGroup recodeGroup = new ButtonGroup();
		recodeGroup.add(recode);
		recode.setSelected(true);
		recodeGroup.add(recodeAD);
		recodeGroup.add(recode12);
		recodeGroup.add(recodeHV);
		recodeGroup.add(makeBin);
		
		//body.setBorder(new TitledBorder("Output Options"));
		body.setLayout(new BoxLayout(body, BoxLayout.PAGE_AXIS));
		body.add(recode);
		body.add(recode12);
		body.add(recodeAD);
		body.add(recodeHV);
		body.add(makeBin);
		
	}
	
	public RecodeForm(MainFrame mf){
		super(mf, "Generate fileset");
	}

	@Override
	protected void initalize() {
		recode = new myRadioButton("Standard fileset (--recode)");
		recode12 = new myRadioButton("Standard fileset w/ allele recoding " +
				"(--recode12)");
		recodeAD = new myRadioButton("Raw genotype file (--recodeAD)");
		recodeHV = new myRadioButton("Haploview fileset (--recodeHV)");
		makeBin = new myRadioButton("Binary fileset (--make-bed)");
	}
	

}
